function [V, E, A, A2] = Stest2( m,N )

tic
msize = 3;
%disp('Initializing Board...');


%label angles
labels = cellstr( num2str([1:1]') );

% initial set of fixed points
q1 = [0; -1+sqrt(3)];
q2 = [-1; -1];
q3 = [1; -1];

% initial set of vertices and edges
V0 = [q1 q2 q3]; 
E = [2 3 0 0; 1 3 0 0; 1 2 0 0];

% next set of vertices through 3 contractions
V(:,:) = [(1/2*V0 + 1/2*[q1 q1 q1])...
       (1/2*V0 + 1/2*[q2 q2 q2]) (1/2*V0 + 1/2*[q3 q3 q3])];
V = [V(:,1:3) V(:,5) V(:,8:9)] % remove copies
E = [2 3 0 0 ; 1 3 4 5; 1 2 5 6; 2 5 0 0; 2 3 4 6; 3 5 0 0 ]; %new edges
s1 = 2; %value for lower left of topmost triangle
s2 = 5;




A(1,1:2)=[0 0];
A(2,1:2)=[0 1];
A(3,1:2)=[0 2];
A(4,1:2)=[1 1];
A(5,1:2)=[1 2];
A(6,1:2)=[2 2];

A2(1,1:2)=[0 0];
A2(2,1:2)=[1 0];
A2(3,1:2)=[2 0];
A2(4,1:2)=[1 1];
A2(5,1:2)=[2 1];
A2(6,1:2)=[2 2];

for i = 2:m
   s = size(V,2);
   t = size(A,1);
   s0 = (3^(i-1)+3)/2;
   Q1 = repmat(q1,1,size(V(:,:),2));
   Q2 = repmat(q2,1,size(V(:,:),2));
   Q3 = repmat(q3,1,size(V(:,:),2));
   V = [(1/2*V + 1/2*Q1) (1/2*V + 1/2*Q2) (1/2*V + 1/2*Q3)];

   B=size(A,1);
   T=size(A,2);
   
   for j=1:B
       Anew(j,1:T+1)=[0 A(j,:)];
   end
   
   for j=1:B
       Anew(B+j,1:T+1)=[1 A(j,:)];
   end
   
   for j=1:B
       Anew(2*B+j,1:T+1)=[2 A(j,:)];
   end   
   
   A=Anew;
   
   B=size(A2,1);
   T=size(A2,2);
   
   for j=1:B
       A2new(j,1:T+1)=[0 A2(j,:)];
   end
   
   for j=1:B
       A2new(B+j,1:T+1)=[1 A2(j,:)];
   end
   
   for j=1:B
       A2new(2*B+j,1:T+1)=[2 A2(j,:)];
   end   
   
   A2=A2new;
   

   s1 = s1+s0-1;
   s2 = 1/12*(6*i+15*3^i+9); %value of lower left of last triangle
   
   E1 = E+(s-1)*(E>0);  E1(E1 == s) = s1;  E1(E1 == 2*s-1) = s2;
   E2 = E+(2*s-3)*(E>0); E2(E2 == 2*s-2) = s;
   E = [E; E1; E2];
   V = [V(:,1:s) V(:,(s+2):(2*s-1)) V(:,(2*s+2):3*s)];
   E(s1,:) = [E(s1,1:2) E(s+1,1:2)]; E(s,:) = [E(s,1:2) E(2*s+1,1:2)];
   E(s2+3,:) = [E(s2+3,1:2) E(2*s,1:2)]; 
   E = [E(1:s,:); E((s+2):(2*s-1),:) ;E((2*s+2):3*s,:)];

   
   c=zeros(1,size(A,2));
   A = transpose(A);
   A = [A(:,1:t) A(:,(t+2):(2*t-1)) A(:,(2*t+2):3*t)];
   A2 = transpose(A2);
   A2 = [A2(:,1:t) A2(:,(t+2):(2*t-1)) A2(:,(2*t+2):3*t)];
   for j = 1:size(A,2)
    if A(:,j) == A2(:,j)
        c(j)=j;
    else
        c(j)=0;
    end
   end
   
   c(c==0) = [];
   A2(:,c(2))=0;
   A2(:,c(3))=0;
   A2(:,c(5))=2;
   A2(1,c(2))=1;
   A2(1,c(3))=2;
   A2(1,c(5))=1;
   
A=transpose(A);
A2=transpose(A2);
end



% 
% figure;
% hold on;
%toc; disp(' ');
% disp('Drawing Individual Chips...');

% for k = 1:size(E,1)
%     for l = find(E(k,:))
%         h =  plot([V(1,k) V(1,E(k,l)) ],[V(2,k) V(2,E(k,l))],'-ok','MarkerSize', msize);        
%         set(h(1),'MarkerEdgeColor','k','MarkerFaceColor','k');
% 
%         labels = cellstr( num2str(k) );
%         text(V(1,k)+.1,V(2,k), labels)
%     end
% end

%h = plot(V(1,:),V(2,:),'o','MarkerSize',msize);
%set(h(1),'MarkerEdgeColor','k','MarkerFaceColor','k');


%h = plot(V(1,:),V(2,:),'o');

% set(gca,'YTickLabel',[]);
% set(gca,'XTickLabel',[]);
% set(gca,'xtick',[]);
% set(gca,'ytick',[]);
% 
% xlim([-1.5 1.5]);
% ylim([-1.5 (-1+sqrt(3)+.5)]);
% title(['a values on top 1/3 of SG Lv. ' num2str(m+1)]);


% p = plot([-100],[100],'ok',[-100],[200],'ob',[-100],[300],'og',[-100],[400],'or');
% set(p(1),'MarkerEdgeColor','k','MarkerFaceColor','k')
% set(p(2),'MarkerEdgeColor','k','MarkerFaceColor','b')
% set(p(3),'MarkerEdgeColor','k','MarkerFaceColor','g')
% set(p(4),'MarkerEdgeColor','k','MarkerFaceColor','r')
% 
% legend(p,'0 Chips','1 Chip','2 Chips','3 Chips')
% box on











toc
%toc;disp(' ');
%disp('Finished');

end

