function [TotalTri,TotalLen,TotalAng,Areas,TotalArea,energyMatrix,gramMatrix,EigVal] = XFEMGenerator(m,subdiv,const)
tic
%X version / TBD
[Face1,Face2,Face3,Face4,FaceLen,FaceAng,Face1Eq,Face2Eq,Face3Eq,Face4Eq,EqTriLen,EqAng,Face1Fld,Face2Fld,Face3Fld,Face4Fld,FldTriLen,FldTriAng,NVs,EWNVs] = XfaceGluer(m,const);
[GFTri1,GFTriLen1,GFTriAng1,GFTri2,GFTriLen2,GFTriAng2,GFTri3,GFTriLen3,GFTriAng3,GFTri4,GFTriLen4,GFTriAng4,NewVs,edgeWithNewVs] = XgoldFaceCreator(m,const);

TotalTri = [Face1; Face1Eq; Face1Fld; Face2; Face2Eq; Face2Fld; Face3; Face3Eq; Face3Fld; Face4; Face4Eq; Face4Fld; GFTri1; GFTri2; GFTri3; GFTri4];
TotalLen = [FaceLen; EqTriLen; FldTriLen; FaceLen; EqTriLen; FldTriLen; FaceLen; EqTriLen; FldTriLen; FaceLen; EqTriLen; FldTriLen; GFTriLen1; GFTriLen2; GFTriLen3; GFTriLen4];
TotalAng = [FaceAng; EqAng; FldTriAng; FaceAng; EqAng; FldTriAng; FaceAng; EqAng; FldTriAng; FaceAng; EqAng; FldTriAng; GFTriAng1; GFTriAng2; GFTriAng3; GFTriAng4];

TotalNVs = [NVs; NewVs];
TotalEWNVs = [EWNVs; edgeWithNewVs];

for s=1:subdiv
    TotalEdges = edgeSplitter(TotalTri);
    TotalEdges = unique(TotalEdges,'rows');
    newVs = zeros(size(TotalEdges,1),1);
    %if s==1
        for j=1:size(TotalEWNVs,1)
            idx = findRow(TotalEdges,TotalEWNVs(j,:));
            if ~isnan(idx)
                newVs(idx,:) = TotalNVs(j,:);
            end
            idx2 = findRow(TotalEdges,[TotalEWNVs(j,2) TotalEWNVs(j,1)]);
            if ~isnan(idx2)
                newVs(idx2,:) = TotalNVs(j,:);
            end
        end
    %end
        
    for i=1:size(newVs,1)        
        index1 = findRow(TotalEdges,[TotalEdges(i,2) TotalEdges(i,1)]);
        if newVs(i,:) == 0
            newVs(i,:) = max(max(TotalTri)) + i;
        end
        if ~isnan(index1) 
            if newVs(index1,:) == 0 
                newVs(index1,:) = max(max(TotalTri)) + i;
            end
        end
    end

    newTri = [];
    newLen = [];
    newAng = [];
    count = 1; 
    for i=1:size(TotalTri,1)
        tempEdges = edgeSplitter(TotalTri(i,:));
        index1 = findRow(TotalEdges,tempEdges(1,:));
        index2 = findRow(TotalEdges,tempEdges(2,:));
        index3 = findRow(TotalEdges,tempEdges(3,:));
        tempV1 = newVs(index1,:);
        tempV2 = newVs(index2,:);
        tempV3 = newVs(index3,:);
        newTri(count,:) = [TotalTri(i,1) tempV1 tempV3];
        newAng(count,1) = TotalAng(i,1);
        newLen(count,2) = 1/2*TotalLen(i,2);
        newLen(count,3) = 1/2*TotalLen(i,3);
        newLen(count,1) = sqrt(newLen(count,2)^2 + newLen(count,3)^2 - 2*newLen(count,2)*newLen(count,3)*cos(newAng(count,1)));
        newAng(count,2) = acos((newLen(count,1)^2 + newLen(count,3)^2 - newLen(count,2)^2)/(2*newLen(count,1)*newLen(count,3)));
        newAng(count,3) = acos((newLen(count,1)^2 + newLen(count,2)^2 - newLen(count,3)^2)/(2*newLen(count,1)*newLen(count,2)));

        newTri(count+1,:) = [TotalTri(i,2) tempV2 tempV1];
        newAng(count+1,1) = TotalAng(i,2);
        newLen(count+1,2) = 1/2*TotalLen(i,3);
        newLen(count+1,3) = 1/2*TotalLen(i,1);
        newLen(count+1,1) = sqrt(newLen(count+1,2)^2 + newLen(count+1,3)^2 - 2*newLen(count+1,2)*newLen(count+1,3)*cos(newAng(count+1,1)));
        newAng(count+1,2) = acos((newLen(count+1,1)^2 + newLen(count+1,3)^2 - newLen(count+1,2)^2)/(2*newLen(count+1,1)*newLen(count+1,3)));
        newAng(count+1,3) = acos((newLen(count+1,1)^2 + newLen(count+1,2)^2 - newLen(count+1,3)^2)/(2*newLen(count+1,1)*newLen(count+1,2)));

        newTri(count+2,:) = [TotalTri(i,3) tempV2 tempV3];
        newAng(count+2,1) = TotalAng(i,3);
        newLen(count+2,2) = 1/2*TotalLen(i,2);
        newLen(count+2,3) = 1/2*TotalLen(i,1);
        newLen(count+2,1) = sqrt(newLen(count+2,2)^2 + newLen(count+2,3)^2 - 2*newLen(count+2,2)*newLen(count+2,3)*cos(newAng(count+2,1)));
        newAng(count+2,2) = acos((newLen(count+2,1)^2 + newLen(count+2,3)^2 - newLen(count+2,2)^2)/(2*newLen(count+2,1)*newLen(count+2,3)));
        newAng(count+2,3) = acos((newLen(count+2,1)^2 + newLen(count+2,2)^2 - newLen(count+2,3)^2)/(2*newLen(count+2,1)*newLen(count+2,2)));

        newTri(count+3,:) = [tempV1 tempV2 tempV3];
        newLen(count+3,1) = newLen(count+2,1);
        newLen(count+3,2) = newLen(count,1);
        newLen(count+3,3) = newLen(count+1,1);
        newAng(count+3,1) = acos((newLen(count+3,2)^2 + newLen(count+3,3)^2 - newLen(count+3,1)^2)/(2*newLen(count+3,2)*newLen(count+3,3)));
        newAng(count+3,2) = acos((newLen(count+3,1)^2 + newLen(count+3,3)^2 - newLen(count+3,2)^2)/(2*newLen(count+3,1)*newLen(count+3,3)));
        newAng(count+3,3) = acos((newLen(count+3,1)^2 + newLen(count+3,2)^2 - newLen(count+3,3)^2)/(2*newLen(count+3,1)*newLen(count+3,2)));

        count = count + 4;
    end

    TotalTri = newTri;
    TotalLen = newLen;
    TotalAng = newAng;
    
    TotalEWNVs = TotalEdges;
    TotalNVs = newVs;
end

lastVVal = max(max(TotalTri));

Areas = zeros(size(TotalTri,1),1);
for i=1:size(TotalTri)
    semiP = sum(TotalLen(i,1:3))/2;
    Areas(i,:) = sqrt(semiP*(semiP-TotalLen(i,1))*(semiP-TotalLen(i,2))*(semiP-TotalLen(i,3)));
end
TotalArea = sum(Areas);

energyMatrix = zeros(lastVVal,lastVVal);
gramMatrix = zeros(lastVVal,lastVVal);
%energyMatrix = sparse(lastVVal,lastVVal);
%gramMatrix = sparse(lastVVal,lastVVal);

for i=1:size(TotalTri,1)
    tempV1 = TotalTri(i,1);
    tempV2 = TotalTri(i,2);
    tempV3 = TotalTri(i,3);
    gramMatrix(tempV1,tempV1) = gramMatrix(tempV1,tempV1) + 1/6*Areas(i,:);
    gramMatrix(tempV2,tempV2) = gramMatrix(tempV2,tempV2) + 1/6*Areas(i,:);
    gramMatrix(tempV3,tempV3) = gramMatrix(tempV3,tempV3) + 1/6*Areas(i,:);
    gramMatrix(tempV1,tempV2) = gramMatrix(tempV1,tempV2) + 1/12*Areas(i,:);
    gramMatrix(tempV2,tempV3) = gramMatrix(tempV2,tempV3) + 1/12*Areas(i,:);
    gramMatrix(tempV3,tempV1) = gramMatrix(tempV3,tempV1) + 1/12*Areas(i,:);
     
    gramMatrix(tempV2,tempV1) = gramMatrix(tempV2,tempV1) + 1/12*Areas(i,:);
    gramMatrix(tempV3,tempV2) = gramMatrix(tempV3,tempV2) + 1/12*Areas(i,:);
    gramMatrix(tempV1,tempV3) = gramMatrix(tempV1,tempV3) + 1/12*Areas(i,:);
    

    energyMatrix(tempV1,tempV1) = energyMatrix(tempV1,tempV1) + (TotalLen(i,1)^2)/(4*Areas(i,:));
    energyMatrix(tempV2,tempV2) = energyMatrix(tempV2,tempV2) + (TotalLen(i,2)^2)/(4*Areas(i,:));
    energyMatrix(tempV3,tempV3) = energyMatrix(tempV3,tempV3) + (TotalLen(i,3)^2)/(4*Areas(i,:));
    energyMatrix(tempV1,tempV2) = energyMatrix(tempV1,tempV2) - (1/2)*cot(TotalAng(i,3));
    energyMatrix(tempV2,tempV3) = energyMatrix(tempV2,tempV3) - (1/2)*cot(TotalAng(i,1));
    energyMatrix(tempV3,tempV1) = energyMatrix(tempV3,tempV1) - (1/2)*cot(TotalAng(i,2));
        
    energyMatrix(tempV2,tempV1) = energyMatrix(tempV2,tempV1) - (1/2)*cot(TotalAng(i,3));
    energyMatrix(tempV3,tempV2) = energyMatrix(tempV3,tempV2) - (1/2)*cot(TotalAng(i,1));
    energyMatrix(tempV1,tempV3) = energyMatrix(tempV1,tempV3) - (1/2)*cot(TotalAng(i,2));
end
gramMatrix(all(~gramMatrix,2),:) = [];
gramMatrix(:,all(~gramMatrix,1)) = [];

energyMatrix(all(~energyMatrix,2),:) = [];
energyMatrix(:,all(~energyMatrix,1)) = [];

%Compute the whole spectrum
EigVal = eig(energyMatrix,gramMatrix);

%Compute the first 100 eigenvalues
%EigVal = eigs(energyMatrix, gramMatrix, 100, 'smallestabs');

%Save these
%save("FC_" + m + "_" + subdiv + ".mat", 'EigVal')
save("Area_" + m + "_" + subdiv + ".mat", 'TotalArea')

%We don't normalize
%EigVal = EigVal/TotalArea;
toc
end

