function [Edges,EdgeLen] = XedgeCreator(m,const)
%X - improved version
%edgeCreator - at level m, this function creates an array of all unique
%  edges on our curved face up to this point (before creation of upside 
%  down triangle) called Edges with their corresponding lengh located in
%  EdgeLen. For all trinagles (i,j,k) in Tri with corresponding lengths 
%  (len1,len2,len3) in LenM, this function splits them (i,j) >> len3, (j,k)
%  >> len1, and (k,i) >> len2.
[Tri,~,~,~,~,~,~] = XtriangleCreator(m);
[~,~,LenM] = XLengthGenerator(m,const);

Edges = zeros(size(Tri,1)*3,2);

EdgeLen = zeros(size(Edges,1),1);

TriRows = size(Tri,1);
% (i,j) >> len3
Edges(1:TriRows,:) = [Tri(:,1) Tri(:,2)];
EdgeLen(1:TriRows,:) = LenM(:,3);

% (j,k) >> len1
Edges((TriRows+1):(2*TriRows),:) = [Tri(:,2) Tri(:,3)];
EdgeLen((TriRows+1):(2*TriRows),:) = LenM(:,1);
 
% (k,i) >> len2
Edges((2*TriRows+1):(3*TriRows),:) = [Tri(:,3) Tri(:,1)];
EdgeLen((2*TriRows+1):(3*TriRows),:) = LenM(:,2);

end

