function [EqTri,EqTriLen,EqAng] = XnewEquilateralCreator(m,const)
%X - improved version / TBD
%newEquilateralCreator - at level m, this function creates the upside down
%  equilateral triangles. The output also contains their lengths and angles 
%  (pi/3). There will be 3^(m-1) such triangles.
[A,A2] = XbinaryNames(m);
[Edges,EdgeLen] = XedgeCreator(m,const);
EqTri = zeros(3^(m-1),3);
EqTriLen = zeros(3^(m-1),3);

%CombDr does the tertiary counting on the m-1 slots.
CombDr = dec2base(0:3^(m-1)-1,3,m-1) - '0';
if size(CombDr,1) == 1
        CombDr = zeros(1,0);
end

%FOR LOOP creates the EqTri array containing the upside down eq. triangles
%  based on tertiary couting and finds their corresponding vertex value
count = 1;
for dr=1:size(CombDr,1)
    tempV1 = [CombDr(dr,:) 0 1];
    tempV2 = [CombDr(dr,:) 0 2];
    tempV3 = [CombDr(dr,:) 1 2];
    index1 = findRow(A,tempV1);
    index2 = findRow(A,tempV2);
    index3 = findRow(A,tempV3);    
    if isnan(index3)
        index3 = findRow(A2,tempV3);
    end
    EqTri(count,:) = [index1 index2 index3];    
    count = count + 1;
end

%FOR LOOP creates the EqTriLen array by going through all triangles (i) and
%  all  subsequent 3 edges (j) these triangles have. Each edge is then
%  matched with its length from EdgeLen.
for i=1:size(EqTri,1)
    for j=1:3
        temp1 = mod(j,3)+1;
        temp2 = mod(j+1,3)+1;
        tempV = [EqTri(i,temp1) EqTri(i,temp2)];
        tempVR = [EqTri(i,temp2) EqTri(i,temp1)];
        % V = [x y] then VR = [y x]
        index = findRow(Edges, tempV);
        if isnan(index)
            index = findRow(Edges, tempVR);
        end
        EqTriLen(i,j) = EdgeLen(index,:);
    end   
end
EqAng = ones(3^(m-1),3)*(pi/3);
end

